<ng-container *subscribe="createFeedback.result$ as createFeedback">
  <ngx-loading [show]="createFeedback.isLoading" />
</ng-container>

<jds-bi-modal
  #modal
  [id]="modalId"
  [position]="'center'"
  [ngClass]="'modal-feedback'"
>
  <ng-container ngProjectAs="header">
    <h5></h5>
    <button
      class="t-button-close"
      (click)="closeModal()"
      role="button"
      type="button"
    >
      <jds-bi-icon
        [size]="14"
        name="xmark"
      />
    </button>
  </ng-container>
  <ng-container ngProjectAs="body">
    <form
      class="form"
      #feedbackForm="ngForm"
      [formGroup]="myForm"
      (ngSubmit)="onSubmit()"
      (keydown.enter)="$event.stopPropagation()"
    >
      <div [ngClass]="[jds.textAlign('center'), jds.mb(24)]">
        <img
          [ngClass]="[
            jds.d('block'),
            jds.minW('full'),
            jds.mx('auto'),
            jds.mb(24)
          ]"
          height="42"
          loading="lazy"
          src="assets/images/logo/satu-data-jabar-black.svg"
          alt="Satu Data Jabar"
        />
        Bantu kami meningkatkan layanan dengan feedback Anda.
      </div>

      <div [ngClass]="[jds.mb(16), jds.textAlign('center')]">
        <label [ngClass]="jds.formLabel">
          Seberapa puaskah Anda dengan layanan Satu Data Jabar?
          <span [ngClass]="jds.text('danger')">*</span>
        </label>
        <input
          [colorScheme]="colorScheme"
          [hidden]="true"
          type="hidden"
          jdsBiInput
          formControlName="score"
        />
        <div [ngClass]="[className.score, isScore ? 'active' : '']">
          <div
            *ngFor="let row of scoreList"
            [ngClass]="[jds.w('1/5')]"
          >
            <a
              [ngClass]="{ active: activeScore === row.value }"
              (click)="onSelectedScore(row.value)"
            >
              <img
                [ngClass]="[
                  jds.d('block'),
                  jds.minW('full'),
                  jds.mx('auto'),
                  jds.mb(5)
                ]"
                [alt]="row.name"
                [src]="'assets/images/feedback/' + row.image"
                height="40"
                loading="lazy"
              />
              <span>{{ row.name }}</span>
            </a>
          </div>
        </div>
      </div>

      <div [ngClass]="jds.mb(16)">
        <label [ngClass]="jds.formLabel">
          Apakah tujuan utama Anda mengunjungi laman Satu Data Jabar hari ini
          <span [ngClass]="jds.text('danger')">*</span>
        </label>
        <ng-container *subscribe="feedbackInfoData$ as feedbackInfo">
          <ng-select
            #purposeSelect
            [items]="
              feedbackInfo.isSuccess ? feedbackInfo.data.list.tujuan : []
            "
            (ngModelChange)="onSelectedPurpose($event)"
            bindValue="nama"
            bindLabel="nama"
            placeholder="Pilih Tujuan"
            formControlName="tujuan"
          />
        </ng-container>
        <ng-container
          *ngIf="f.tujuan?.invalid && (f.tujuan?.dirty || f.tujuan?.touched)"
        >
          <div
            *ngIf="f.tujuan?.errors.required"
            [ngClass]="[jds.formText, jds.text('danger')]"
          >
            Harus diisi
          </div>
        </ng-container>
      </div>

      <div
        *ngIf="isPurposeOther"
        [ngClass]="jds.mb(16)"
      >
        <textarea
          [colorScheme]="colorScheme"
          jdsBiInput
          placeholder="Tuliskan tujuan Anda"
          rows="2"
          formControlName="tujuan_other"
        ></textarea>
        <ng-container
          *ngIf="
            f.tujuan_other?.invalid &&
            (f.tujuan_other?.dirty || f.tujuan_other?.touched)
          "
        >
          <div
            *ngIf="f.tujuan_other?.errors.required"
            [ngClass]="[jds.formText, jds.text('danger')]"
          >
            Harus diisi
          </div>
          <div
            *ngIf="f.tujuan_other?.errors.maxlength"
            [ngClass]="[jds.formText, jds.text('danger')]"
          >
            Panjang maksimal 255 karakter.
          </div>
        </ng-container>
      </div>

      <div [ngClass]="jds.mb(16)">
        <label [ngClass]="jds.formLabel">
          Apakah Anda berhasil menemukan data atau informasi yang Anda cari?
          <span [ngClass]="jds.text('danger')">*</span>
        </label>
        <div>
          <div [ngClass]="[jds.formCheck]">
            <input
              [ngClass]="[jds.formCheckInput]"
              (click)="onSelectedPurposeAchieved($event.target.value)"
              value="true"
              type="radio"
              formControlName="tujuan_tercapai"
            />
            <label [ngClass]="[jds.formCheckLabel]"> Ya </label>
          </div>
          <div [ngClass]="[jds.formCheck]">
            <input
              [ngClass]="[jds.formCheckInput]"
              (click)="onSelectedPurposeAchieved($event.target.value)"
              value="false"
              type="radio"
              formControlName="tujuan_tercapai"
            />
            <label [ngClass]="[jds.formCheckLabel]"> Tidak </label>
          </div>
        </div>
        <ng-container
          *ngIf="
            f.tujuan_tercapai?.invalid &&
            (f.tujuan_tercapai?.dirty || f.tujuan_tercapai?.touched)
          "
        >
          <div
            *ngIf="f.tujuan_tercapai?.errors.required"
            [ngClass]="[jds.formText, jds.text('danger')]"
          >
            Harus diisi
          </div>
        </ng-container>
      </div>

      <div
        *ngIf="isPurposeEasyFind"
        [ngClass]="jds.mb(16)"
      >
        <label [ngClass]="jds.formLabel">
          Apakah informasi yang anda cari mudah untuk didapatkan?
          <span [ngClass]="jds.text('danger')">*</span>
        </label>
        <div>
          <div [ngClass]="[jds.formCheck]">
            <input
              [ngClass]="[jds.formCheckInput]"
              value="true"
              type="radio"
              formControlName="tujuan_mudah_ditemukan"
            />
            <label [ngClass]="[jds.formCheckLabel]"> Ya </label>
          </div>
          <div [ngClass]="[jds.formCheck]">
            <input
              [ngClass]="[jds.formCheckInput]"
              value="false"
              type="radio"
              formControlName="tujuan_mudah_ditemukan"
            />
            <label [ngClass]="[jds.formCheckLabel]"> Tidak </label>
          </div>
        </div>
        <ng-container
          *ngIf="
            f.tujuan_mudah_ditemukan?.invalid &&
            (f.tujuan_mudah_ditemukan?.dirty ||
              f.tujuan_mudah_ditemukan?.touched)
          "
        >
          <div
            *ngIf="f.tujuan_mudah_ditemukan?.errors.required"
            [ngClass]="[jds.formText, jds.text('danger')]"
          >
            Harus diisi
          </div>
        </ng-container>
      </div>

      <ng-container *ngIf="!isPurposeEasyFind">
        <div [ngClass]="jds.mb(16)">
          <label [ngClass]="jds.formLabel">
            Manakah dari masalah dalam mendapatkan data berikut yang Anda alami?
            <span [ngClass]="jds.text('danger')">*</span>
          </label>
          <ng-container *subscribe="feedbackInfoData$ as feedbackInfo">
            <ng-select
              #problemSelect
              [items]="
                feedbackInfo.isSuccess ? feedbackInfo.data.list.masalah : []
              "
              (ngModelChange)="onSelectedProblem($event)"
              bindValue="nama"
              bindLabel="nama"
              placeholder="Pilih Masalah"
              formControlName="masalah"
            />
          </ng-container>
          <ng-container
            *ngIf="
              f.masalah?.invalid && (f.masalah?.dirty || f.masalah?.touched)
            "
          >
            <div
              *ngIf="f.masalah?.errors.required"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Harus diisi
            </div>
          </ng-container>
        </div>

        <div
          *ngIf="isProblemOther"
          [ngClass]="jds.mb(16)"
        >
          <textarea
            [colorScheme]="colorScheme"
            jdsBiInput
            placeholder="Tuliskan masalah Anda"
            rows="2"
            formControlName="masalah_other"
          ></textarea>
          <ng-container
            *ngIf="
              f.masalah_other?.invalid &&
              (f.masalah_other?.dirty || f.masalah_other?.touched)
            "
          >
            <div
              *ngIf="f.masalah_other?.errors.required"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Harus diisi
            </div>
            <div
              *ngIf="f.masalah_other?.errors.maxlength"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Panjang maksimal 255 karakter.
            </div>
          </ng-container>
        </div>
      </ng-container>

      <div [ngClass]="jds.mb(16)">
        <label [ngClass]="jds.formLabel">
          Berikan Saran dan masukan Anda untuk Satu Data Jabar agar kami dapat
          memberikan layanan lebih baik lagi
        </label>
        <textarea
          [colorScheme]="colorScheme"
          jdsBiInput
          placeholder="Tuliskan saran Anda"
          rows="5"
          formControlName="saran"
        ></textarea>
        <ng-container
          *ngIf="f.saran?.invalid && (f.saran?.dirty || f.saran?.touched)"
        >
          <div
            *ngIf="f.saran?.errors.required"
            [ngClass]="[jds.formText, jds.text('danger')]"
          >
            Harus diisi
          </div>
          <div
            *ngIf="f.saran?.errors.maxlength"
            [ngClass]="[jds.formText, jds.text('danger')]"
          >
            Panjang maksimal 255 karakter.
          </div>
        </ng-container>
      </div>
    </form>
  </ng-container>
  <ng-container ngProjectAs="footer">
    <div [ngClass]="[jds.d('flex'), jds.gap(8)]">
      <button
        [colorScheme]="'gray'"
        [variant]="'outline'"
        (click)="closeModal()"
        jdsBiButton
        type="button"
      >
        Batal
      </button>
      <button
        [colorScheme]="colorScheme"
        [disabled]="!feedbackForm.valid"
        (click)="feedbackForm.ngSubmit.emit('Save')"
        jdsBiButton
        type="submit"
      >
        Kirim
      </button>
    </div>
  </ng-container>
</jds-bi-modal>
